<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_Transfer ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_Transfer extends AbstractStructArrayBase
{
    /**
     * The Transfer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_Transfer[]
     */
    public $Transfer;
    /**
     * Constructor method for ArrayOfJP_Transfer
     * @uses ArrayOfJP_Transfer::setTransfer()
     * @param \StructType\JP_Transfer[] $transfer
     */
    public function __construct(array $transfer = array())
    {
        $this
            ->setTransfer($transfer);
    }
    /**
     * Get Transfer value
     * @return \StructType\JP_Transfer[]|null
     */
    public function getTransfer()
    {
        return $this->Transfer;
    }
    /**
     * This method is responsible for validating the values passed to the setTransfer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTransfer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTransferForArrayConstraintsFromSetTransfer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_TransferTransferItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_TransferTransferItem instanceof \StructType\JP_Transfer) {
                $invalidValues[] = is_object($arrayOfJP_TransferTransferItem) ? get_class($arrayOfJP_TransferTransferItem) : sprintf('%s(%s)', gettype($arrayOfJP_TransferTransferItem), var_export($arrayOfJP_TransferTransferItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Transfer property can only contain items of type \StructType\JP_Transfer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Transfer value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Transfer[] $transfer
     * @return \ArrayType\ArrayOfJP_Transfer
     */
    public function setTransfer(array $transfer = array())
    {
        // validation for constraint: array
        if ('' !== ($transferArrayErrorMessage = self::validateTransferForArrayConstraintsFromSetTransfer($transfer))) {
            throw new \InvalidArgumentException($transferArrayErrorMessage, __LINE__);
        }
        $this->Transfer = $transfer;
        return $this;
    }
    /**
     * Add item to Transfer value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Transfer $item
     * @return \ArrayType\ArrayOfJP_Transfer
     */
    public function addToTransfer(\StructType\JP_Transfer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_Transfer) {
            throw new \InvalidArgumentException(sprintf('The Transfer property can only contain items of type \StructType\JP_Transfer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Transfer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_Transfer|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_Transfer|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_Transfer|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_Transfer|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_Transfer|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Transfer
     */
    public function getAttributeName()
    {
        return 'Transfer';
    }
}
